/************************************************************************
 *									*
 *		VurdVXe@ob|bmrvO		*
 *									*
 *				: C				*
 *		t@C	: main.c				*
 *		쐬		: 91/04/01				*
 *									*
 ************************************************************************/

#include "pc_cns.h"

/*	֐`	*/
static	void	interrupt far	int_stop(void);
static	void	set_gaiji(void);

/*	X^eBbNϐ	*/
static	struct key_buf	func_save; /* t@NVL[f[^Z[uGA */
void	(far interrupt *stop_vect)();

/*=======================================================================
 |
 |		C
 |
 |	int	main()
 |
 =======================================================================*/
int	main(int argc, char *argv[])
{
	/* IvV`FbN */
	while (--argc) {
		argv++;
		if (strcmp(*argv, "/T") == 0 || strcmp(*argv, "/t") == 0)
			opt_t = 1;
		else {
			printf("Bad option '%s'\n", *argv);
			exit(1);
		}
	}

	initialize();		/*  */

	find_csg();		/* R\[rft@C */
	read_csg();		/* R\[rft@Cǂݍ */
	read_cmdfile();		/* R}hIt@Cǂݍ */
	read_msgfile();		/* bZ[Wt@Cǂݍ */

	if (loctbl == NULL) {
		final();
		printf("[JR}hIt@C܂.\n");
		exit(1);
	}

	/* JnbZ[Wo */
	dsp_loc_msg(LOC_MSG_START, csg.nsg.sys_name);

	exec_prog(1);		/* eN */

	final();		/* I */

	return(0);
}

/*=======================================================================
 |
 |		
 |
 |	void	initialize()
 |
 =======================================================================*/
void	initialize()
{
	signal(SIGINT, SIG_IGN);	/* rsnoL[𖳎 */

	stop_vect = _dos_getvect(0x06);	/* rsnoL[荞݃xN^ۑ */
	_dos_setvect(0x06, int_stop);	/* rsnoL[荞ݐݒ */

	/*set_err_handler();*/	/* G[nhZbg */

	t_fget(&func_save);	/* t@NVL[xo */
	t_fput(&key_data);	/* t@NVL[xݒ */

	cputs("\x1b[>1h");	/* ŉʍs[Ugp */
	t_csroff();		/* J[\ */

	g_init();		/* OtBbN */
	g_screen(3, 0, 0, 1);	/* XN[[hݒ */
	g_cls();		/* OtBbNʃNA */
	t_cls();		/* eLXgʃNA */
	mouse = m_init();	/* }EXhCo */
	set_gaiji();		/* OZbg */
}

/*=======================================================================
 |
 |		rsnoL[荞ݏ
 |
 |	void	int_stop()
 |
 =======================================================================*/
static	void	interrupt far	int_stop()
{
	stop_flag = 1;		/* rsnoL[tOZbg */
}

/*=======================================================================
 |
 |		Oݒ菈
 |
 |	void	set_gaiji()
 |
 =======================================================================*/
static	void	set_gaiji()
{
	static	char	gaiji_7622[] = {	/* ^[L[	*/
		0x02, 0x02,
		0x00, 0x00, 0x00, 0x00, 0x3f, 0xfc, 0x20, 0x04,
		0x20, 0x74, 0x20, 0x54, 0x22, 0x54, 0x26, 0x54,
		0x2b, 0x94, 0x30, 0x24, 0x2b, 0xc4, 0x26, 0x04,
		0x22, 0x04, 0x3f, 0xfc, 0x00, 0x00, 0x00, 0x00
	};
	static	char	gaiji_7628[] = {	/* db@̃}[N */
		0x02, 0x02,
		0x00, 0x00, 0x0f, 0xf0, 0x3f, 0xfc, 0x7c, 0x3e,
		0x74, 0x2e, 0x74, 0x2e, 0x07, 0xe0, 0x1f, 0xf8,
		0x1c, 0x38, 0x30, 0x0c, 0x30, 0x0c, 0x70, 0x0e,
		0x70, 0x0e, 0x7c, 0x3e, 0x7f, 0xfe, 0x00, 0x00
	};
	static	char	gaiji_763d[] = {	/* db̃}[N */
		0x02, 0x02,
		0x01, 0x80, 0x03, 0x80, 0x07, 0x80, 0x0d, 0x80,
		0x19, 0x80, 0x31, 0x80, 0x61, 0x80, 0xc1, 0x81,
		0x81, 0x83, 0x01, 0x86, 0x01, 0x8c, 0x01, 0x98,
		0x01, 0xb0, 0x01, 0xe0, 0x01, 0xc0, 0x01, 0x80
	};
	static	char	gaiji_7643[] = {	/* fBXÑ}[N */
		0x02, 0x02,
		0x0f, 0xf0, 0x38, 0x1c, 0x60, 0x06, 0xe0, 0x07,
		0xb8, 0x1d, 0x8f, 0xf1, 0x80, 0x01, 0x80, 0x01,
		0x80, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x01,
		0xc0, 0x03, 0x60, 0x06, 0x3c, 0x3c, 0x07, 0xe0
	};
	static	char	gaiji_7653[] = {	/* _̎lp */
		0x02, 0x02,
		0x00, 0x00, 0x4a, 0xaa, 0x00, 0x00, 0x40, 0x00,
		0x00, 0x02, 0x40, 0x00, 0x00, 0x02, 0x40, 0x00,
		0x00, 0x02, 0x40, 0x00, 0x00, 0x02, 0x40, 0x00,
		0x00, 0x02, 0x00, 0x00, 0x55, 0x52, 0x00, 0x00
	};

	t_setfont(0x7622, gaiji_7622);
	t_setfont(0x7628, gaiji_7628);
	t_setfont(0x763d, gaiji_763d);
	t_setfont(0x7643, gaiji_7643);
	t_setfont(0x7653, gaiji_7653);
}

/*=======================================================================
 |
 |		I
 |
 |	void	final()
 |
 =======================================================================*/
void	final()
{
	_dos_setvect(0x06, stop_vect);	/* rsnoL[荞݃xN^A */

	t_color(0xe1);		/* F𔒂ɐݒ */

	cputs("\x1b[>1l");	/* ŉʍsVXegp */
	t_fput(&func_save);	/* t@NVL[xݒ */

	t_csron();		/* J[\\ */
	m_csroff();		/* }EXJ[\nee */

	g_cls();		/* OtBbNʃNA */
	t_cls();		/* eLXgʃNA */

	rs1_close();		/* qr|QRQbN[Y */

	timreset();		/* ^C}[Zbg */

	/*spawnlp(0, "MEM", "MEM", 0L);*/	/* TCY\ */
}
